// this is an effect template. use it to start writing your own effects.

// -------------------------------------------------------------------------------------------------------------------------------------
// PARAMETERS:
// -------------------------------------------------------------------------------------------------------------------------------------

//transforms
float4x4 tW: WORLD;        //the models world matrix
float4x4 tV: VIEW;         //view matrix as set via Renderer (DX9)
float4x4 tP: PROJECTION;   //projection matrix as set via Renderer (DX9)
float4x4 tWVP: WORLDVIEWPROJECTION;


 //texture
texture Tex1 <string uiname="Texture1";>;


float4x4 tTex <string uiname="Texture Transform";>;                  //Texture Transform
sampler2D Samp = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex1);          //apply a texture to the sampler
    MipFilter = LINEAR;         //set the sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};




float4x4 tColor  <string uiname="Color Transform";>;

//Parameters

float fade =1;
float Contrast=1 ;
float lumaswitch ;
float4 colour =.5;
float luma;
float4 trans;



// -------------------------------------------------------------------------------------------------------------------------------------
// VERTEXSHADERS
// -------------------------------------------------------------------------------------------------------------------------------------

struct VS_OUTPUT
{
    float4 Pos  : POSITION;
    float2 TexC : TEXCOORD0;
};

VS_OUTPUT VS(
    float4 Pos  : POSITION,
    float2 TexC : TEXCOORD)
{
    //inititalize all fields of output struct with 0
    VS_OUTPUT Out = (VS_OUTPUT)0;

    //transform position
    Pos = mul(Pos, tWVP);
    //transform texturecoordinates
    TexC = mul(trans.zw*TexC, tTex);
   TexC = TexC+trans.xy;

    Out.Pos  = Pos;
    Out.TexC = TexC;

    return Out;
}

// -------------------------------------------------------------------------------------------------------------------------------------
// PIXELSHADERS:
// -------------------------------------------------------------------------------------------------------------------------------------

float4 PS_cat(float2 TexC: TEXCOORD0): COLOR



{


    float4 col = tex2D(Samp, TexC) ;


    col.rgb = clamp(colour.rgb + col.rgb,0,1) ;       // RGB +/-
//if (colour.r<0.2 || colour.r>0.8) colour.r = 0.0f; else colour.r = 1.0f;

  col.a=1;

 if (col.r+col.g+col.b<luma*3   ) col.a = lumaswitch; else  col.a = 1-lumaswitch;//col.a-lumaswitch ;     // Luma



  col.rgb =  ((col.rgb -0.5)*Contrast)+0.5  ;  // contrast
  col = clamp(col * fade,0,1)  ;    //level



    return col;
}

// -------------------------------------------------------------------------------------------------------------------------------------
// TECHNIQUES:
// -------------------------------------------------------------------------------------------------------------------------------------

technique TSimpleShader
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS_cat();
    }
}

technique TFixedFunction
{
    pass P0
    {
        //transforms
        WorldTransform[0]   = (tW);
        ViewTransform       = (tV);
        ProjectionTransform = (tP);


        //texturing
        Sampler[0] = (Samp);
        TextureTransform[0] = (tTex);
        TexCoordIndex[0] = 0;
        TextureTransformFlags[0] = COUNT2;


        LightEnable[0] = TRUE;
        Lighting       = TRUE;
        SpecularEnable = TRUE;

        //shaders
        VertexShader = NULL;
        PixelShader  = NULL;
    }
}
